/// <reference types="chrome" />
import { AnyAction as ReduxAction, Store as ReduxStore, Dispatch as ReduxDispatch, Unsubscribe, AnyAction, Reducer as ReduxReducer } from 'redux';
export declare type Action = ReduxAction;
export declare type API = typeof chrome;
export declare type Listener = () => void;
export declare type Subscribe<S> = (this: Context<S>, listener: Listener) => Unsubscribe;
export declare type GetState<S> = (this: Context<S>) => S;
export declare type Dispatch<A extends Action> = ReduxDispatch<A>;
export declare type Reducer<S = any, A extends Action = AnyAction> = ReduxReducer<S, A>;
export declare type ReplaceReducer<S = any, A extends Action = AnyAction> = (nextReducer: Reducer<S, A>) => void;
export declare type Store<S, A extends Action> = ReduxStore<S, A>;
export interface Context<S> {
    state: S;
    prevState: S;
    listeners: Listener[];
    sendMessage: typeof chrome.runtime.sendMessage;
}
